VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Debuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Do not modify this file!
'This is part of BNHash functionality and could possibly be updated. If you don't want to lose anywork
'then it's advised that you create your own class.
Option Explicit

Private Enum PacketType
    pIncoming
    pOutgoing
    pNull
End Enum

Public Enum PacketFormat
    pBnet
    pBNLS
End Enum

Private RawData As String
Private Mode As PacketType
Public Position As Long

Public Sub Reset()
    Mode = pNull
    RawData = vbNullString
    Position = 1
End Sub

Public Function SetData(Data As String)
    RawData = Data
    Mode = pIncoming
End Function

Public Function GetData() As String
    GetData = RawData
    Reset
End Function

Public Sub Skip(bytes As Long)
    Position = Position + bytes
End Sub

Public Function GetString() As String
    Dim NTPos&, strTemp$
    GetString = vbNullString
    NTPos = InStr(Position, RawData, vbNullChar)
    If NTPos = 0 Then Exit Function
    GetString = Mid$(RawData, Position, NTPos - Position)
    Position = NTPos + 1
End Function

Public Function GetFixedString(Length As Long) As String
    Dim rVal&
    If LenData() - Position + 1 >= Length Then
        GetFixedString = Mid$(RawData, Position, Length)
        Position = Position + Length
    End If
End Function

Public Function GetBoolean(Optional ByVal bytes As Long = 4) As Boolean
    Dim rVal&
    If LenData() - Position + 1 >= bytes Then
        CopyMemory rVal, ByVal Mid$(RawData, Position, bytes), bytes
        Position = Position + bytes
    End If
    If rVal = 0 Then GetBoolean = False Else GetBoolean = True
End Function

Public Function GetDWORD() As Long
    Dim rVal&
    If LenData() - Position + 1 >= 4 Then
        CopyMemory rVal, ByVal Mid$(RawData, Position, 4), 4
        Position = Position + 4
        GetDWORD = rVal
    End If
End Function

Public Function GetWORD() As Integer
    Dim rVal%
    If LenData() - Position + 1 >= 2 Then
        CopyMemory rVal, ByVal Mid$(RawData, Position, 2), 2
        Position = Position + 2
        GetWORD = rVal
    End If
End Function

Public Function GetBYTE() As Byte
    Dim rVal As Byte
    rVal = 0
    If LenData() - Position + 1 >= 1 Then
        CopyMemory rVal, ByVal Mid$(RawData, Position, 1), 1
        Position = Position + 1
        GetBYTE = rVal
    End If
End Function

Public Function LenData() As Long
    LenData = Len(RawData)
End Function

Public Function StrToHex(ByVal String1 As String) As String
Dim strTemp As String, strReturn As String, i As Long
    
For i = 1 To Len(String1)
    strTemp = Hex(Asc(Mid(String1, i, 1)))
    If Len(strTemp) = 1 Then strTemp = "0" & strTemp
    strReturn = strReturn & " " & strTemp
Next i
    
    StrToHex = strReturn

End Function

Public Function KillNull(ByVal Text As String) As String
    Dim i As Integer
    
    i = InStr(1, Text, Chr(0))
    
    If i = 0 Then
        KillNull = Text
        Exit Function
    End If
    
    KillNull = Left$(Text, i - 1)

End Function

Public Function TheData() As String
TheData = RawData
End Function
